USE Pubs
IF object_id('msp_JobsUpdate') IS NOT NULL
  DROP PROC msp_JobsUpdate
GO
CREATE PROC msp_JobsUpdate (
  @job_id   smallint    -- Ű
, @job_desc varchar(50) = NULL
, @min_lvl  tinyint     = NULL
, @max_lvl  tinyint     = NULL
)
AS
  BEGIN TRAN
  DECLARE @ERR int

  IF @job_desc IS NOT NULL
    BEGIN
      UPDATE jobs
        SET job_desc = @job_desc
        WHERE job_id = @job_id
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  IF @min_lvl IS NOT NULL
    BEGIN
      UPDATE jobs
        SET min_lvl = @min_lvl
        WHERE job_id = @job_id
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  IF @max_lvl IS NOT NULL
    BEGIN
      UPDATE jobs
        SET max_lvl = @max_lvl
        WHERE job_id = @job_id
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_JobsUpdate', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO