USE tempdb

IF OBJECT_ID('copy') IS NOT NULL
  DROP TABLE copy
GO
CREATE TABLE copy (
  copy_id   int IDENTITY PRIMARY KEY,
  copy_name varchar(20) NULL,
  on_loan   char(1) NULL
)

IF OBJECT_ID('loan') IS NOT NULL
  DROP TABLE loan
GO
CREATE TABLE loan (
  loan_id int IDENTITY PRIMARY KEY,
  copy_id int NULL
)

IF OBJECT_ID('tr_LoanInsert') IS NOT NULL
  DROP TRIGGER tr_LoanInsert
GO
CREATE TRIGGER tr_LoanInsert
  ON loan
  FOR INSERT
AS
  DECLARE @copy_id int

  SELECT @copy_id = copy_id
    FROM inserted

  UPDATE copy
    SET on_loan = 'Y'
    WHERE copy_id = @copy_id
GO

IF OBJECT_ID('tr_LoanDelete') IS NOT NULL
  DROP TRIGGER tr_LoanDelete
GO
CREATE TRIGGER tr_LoanDelete
  ON loan
  FOR DELETE
AS
  DECLARE @copy_id int

  SELECT @copy_id = copy_id
    FROM deleted

  UPDATE copy
    SET on_loan = 'N'
    WHERE copy_id = @copy_id
GO

/* copy ̺ ʱ   */
INSERT copy(copy_name, on_loan) VALUES('ﱹ', 'N')
INSERT copy(copy_name, on_loan) VALUES('SQL  2000', 'N')
SELECT * FROM loan
SELECT * FROM copy

/* Test #1: Insert Trigger */
INSERT loan(copy_id) VALUES(1)
SELECT * FROM loan
SELECT * FROM copy

/* Test #2: Delete Trigger */
DELETE loan WHERE copy_id = 1
SELECT * FROM loan
SELECT * FROM copy

IF OBJECT_ID('tr_CopyUpdate') IS NOT NULL
  DROP TRIGGER tr_CopyUpdate
GO
CREATE TRIGGER tr_CopyUpdate
  ON copy
  FOR UPDATE
AS
  DECLARE @ID int, @Loan char

  SELECT @ID = copy_id, @Loan = on_loan
     FROM inserted

  IF UPDATE(on_loan)
    IF @Loan = 'Y'
      INSERT loan(copy_id) VALUES(@ID)
    ELSE	  /* 'N' */
      DELETE loan WHERE copy_id = @ID
GO

/* Test #3: Update Trigger */
UPDATE copy
  SET on_loan = 'Y'
  WHERE copy_id = 2
SELECT * FROM copy
SELECT * FROM loan

/*   |  Ӽ() |   |
   'ٸ ƮŸ ߻Ű ø Ʈ ߻ ' 
   [] exec sp_configure 'netsted triggers', 0 -->  ߻
*/
--> Test #3 !

/* Test #4: Update Trigger */
UPDATE copy
  SET on_loan = 'N'
  WHERE copy_id = 2
SELECT * FROM copy
SELECT * FROM loan

/*   |  Ӽ() |   |
   'ٸ ƮŸ ߻Ű ø Ʈ ߻ ' 
*/