USE tempdb
GO
CREATE PROC msp_AuthorsInsert (
  @kind       bit
  --> 0: freelancer_author, 1: fulltime_author
, @jumin      char(14)
, @sex        bit
, @royalty    int      = NULL
, @yearly_pay int      = NULL
)
AS
  BEGIN TRAN
  DECLARE @ERR int
  DECLARE @ID int

  INSERT author (jumin, sex)
    VALUES (@jumin, @sex)

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR
  SET @ID = @@IDENTITY

  IF (@kind = 0)
    INSERT freelancer_author (author_id, royalty)
      VALUES (@ID, @royalty)
  ELSE
    INSERT fulltime_author (author_id, yearly_pay)
      VALUES (@ID, @yearly_pay)

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  COMMIT TRAN
  RETURN @ID  -- IDENTITY  ȯ
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg =
    dbo.sfn_MakeErrMsg('msp_AuthorsInsert', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO