/* 07_??_SpTr-Template.sql
**
** Academy DB  ν  Ʈŵ
** ϱ  ø(template)
** --> ش  ν Ǵ Ʈ ø  ,
**     ⼭ ۼ ϸ ð   
**
** ۼⰣ: 0306015~
** ۼ:  ձ
*/

USE Academy
GO

/* ====================  ν  ø ==================== */

-- - - - - - - - - - - - - msp_$Insert - - - - - - - - - - - - - -
IF object_id('msp_$Insert') IS NOT NULL
  DROP PROC msp_$Insert
GO
CREATE PROC msp_$Insert (
  @$ = 'Ұɰ'  -- NOT NULL & DEFAULT(s)
, @$ = NULL        -- DEFAULT(s) 
, @$ = NULL
)
AS
  BEGIN TRAN
  DECLARE @ERR int
  DECLARE @ID  int  -- @@IDENTITY    

  /* ڵ ϴ  ( ڵ鵵 ). */
  INSERT $ ($, $, $, $, $)
    VALUES (@$, @$, @$, @$, @$)
  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  SET @ID = @@IDENTITY  --   IDENTITY  

  /* ش    ⺻  */
  IF @$ IS NULL  -- = 'Ұɰ'
    BEGIN
      UPDATE $
        SET $ = DEFAULT
        WHERE $_id = @ID
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  COMMIT TRAN
  RETURN @ID  -- IDENTITY  ȯ
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_$Insert', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_$Update ------------------
IF object_id('msp_$Update') IS NOT NULL
  DROP PROC msp_$Update
GO
CREATE PROC msp_$Update (
  @$_id     int        -- Ű
, @$        varchar()  = NULL
)
AS
  BEGIN TRAN
  DECLARE @ERR int

  IF @$ IS NOT NULL
    BEGIN
      UPDATE $
        SET $ = @$
        WHERE $_id = @$_id
      SET @ERR = @@ERROR
      IF @ERR <> 0  GOTO ERROR
    END

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_$Update', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_$Delete ------------------
IF object_id('msp_$Delete') IS NOT NULL
  DROP PROC msp_$Delete
GO
CREATE PROC msp_$Delete (
  @$_id  int   --  Ű
)
AS
  BEGIN TRAN
  DECLARE @ERR int

  DELETE $
    WHERE $_id = @$_id

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg = dbo.sfn_MakeErrMsg('msp_$Delete', @ERR, DEFAULT)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO

----------------- msp_$SelectAll ------------------
USE Pubs
IF OBJECT_ID('msp_$SelectAll') IS NOT NULL
  DROP PROC msp_$SelectAll
GO
CREATE PROC msp_$SelectAll
AS
  SELECT *
    FROM $
    ORDER BY $_id
GO

----------------- msp_$SelectARow ------------------
IF OBJECT_ID('msp_$SelectARow ') IS NOT NULL
  DROP PROC msp_$SelectARow 
GO
CREATE PROC msp_$SelectARow  (
  @$_id  int
)AS
  SELECT *
    FROM $
    WHERE $_id = @$_id
GO

/* ======================= Ʈ  ======================= */

/*-----------------------< tr_$Insert >-----------------------
[TR#1]
  1. 
   1) 

[TR#2]
  1.
   1) 
*/
IF OBJECT_ID('tr_$Insert') IS NOT NULL
  DROP TRIGGER tr_$Insert
GO
CREATE TRIGGER tr_$Insert
  ON $
  FOR INSERT
AS
  BEGIN TRAN
  DECLARE @ERR int, @custom_err_msg varchar(400)

  /*  Ե ࿡   */
  DECLARE @$_id int
  SELECT @$_id = $_id
    FROM inserted

  ---------- [TR#1] ----------

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  ---------- [TR#2] ----------

  SET @ERR = @@ERROR
  IF @ERR <> 0  GOTO ERROR

  COMMIT TRAN
  RETURN
ERROR:
  DECLARE @error_msg nvarchar(400)
  SET @error_msg =
    dbo.sfn_MakeErrMsg('tr_$Insert', @ERR, @custom_err_msg)
  RAISERROR( @error_msg, 16, 1 )
  ROLLBACK TRAN
GO
